import request from "@/utils/request.js"
// 获取模板列表分页
export function getModuleList(pageNo, pageSize,moduleName,hit,moduleType) {
  return request({
    url: `/engine/module/page?pageNo=${pageNo}&pageSize=${pageSize}&moduleName=${moduleName}&hit=${hit}&moduleType=${moduleType}`,
    method: 'get'
  })
}
// 创建模板
export function createModule(data) {
  return request({
    url: "/engine/module/create",
    method: 'post',
    data: data
  })
}
// 获取单个模板
export function getModule(id) {
  return request({
    url: `/engine/module/get?id=${id}`,
    method: "get"
  })
}
export function delModule(id) {
  return request ({
    url: `/engine/module/delete?id=${id}`,
    method:"delete"
  })
}
export function upDateModule(data) {
  return request ({
    url:'/engine/module/update',
    method:'put',
    data:data
  })
}
// 模板分类
export function createModuleType(data){
  return request ({
    url:'/engine/moduleType/create',
    method:'post',
    data:data
  })
}
export function deleteModuleType(data){
  return request({
    url:`/engine/moduleType/delete?id=${data}`,
    method:'delete'
  })
}
export function getModuleType(data){
  return request({
    url:`/engine/moduleType/get?id=${data}`,
    method:'get'
  })
}
export function getModuleTypeList(){
  return request({
    url:`/engine/moduleType/list`,
    method:'get'
  })
}
export function upDateModuleType(data) {
  return request ({
    url:'/engine/moduleType/update',
    method:'put',
    data:data
  })
}
export function getTypeList(pageNo,pageSize,status,typeName){
  return request({
    url:`/engine/moduleType/page?pageNo=${pageNo}&pageSize=${pageSize}&hit=${status}&typeName=${typeName}`,
    method:'get'
  })
}

// 营销模块
export function createMarket(data){
  return request({
    url:`/engine/market-module/create`,
    method:'post',
    data:data
  })
}
export function getMarketList(pageNo,pageSize,moduleName,status,moduleType){
  return request({
    url:`/engine/market-module/page?pageNo=${pageNo}&pageSize=${pageSize}&moduleName=${moduleName}&hit=${status}&moduleType=${moduleType}`,
    method:'get'
  })
}
export function getMarket(id){
  return request({
    url:`/engine/market-module/get?id=${id}`,
    method:'get'
  })
}
export function deleteMarket(id){
  return request({
    url:`/engine/market-module/delete?id=${id}`,
    method:'delete'
  })
}
export function updateMarket(data){
  return request({
    url:`/engine/market-module/update`,
    method:'put',
    data:data
  })
}
// 渠道管理
// 创建渠道
export function createChannel(data){
  return request({
    url:`/engine/rule-channel-info/create`,
    method:'post',
    data:data
  })
}
// 删除渠道
export function deleteChannel (id) { 
  return request( {
    url:`/engine/rule-channel-info/delete?id=${id}`,
    method:'delete'
  })
 }
// 获取渠道信息
export function getChannel(id) {
  return request({
    url:`/engine/rule-channel-info/get?id=${id}`,
    method:'get'
  })
}
// 获得渠道列表
export function channelList(ids) {
  return request({
    url:`/engine/rule-channel-info/list?ids=${ids}`,
    method:'get'
  })
}

// 获得一级渠道分页
export function ChannelOnePage(pageNo,pageSize,channelName,channelPartner) {
  return request({
    url:`/engine/rule-channel-info/page?pageNo=${pageNo}&pageSize=${pageSize}&channelLevel=1&channelName=${channelName}&channelPartner=${channelPartner}`,
    method:'get'
  })
}
// 获得二级渠道分页
export function ChannelTwoPage(pageNo,pageSize,channelName,fullCode,channelKey,channelPartner) {
  return request({
    url:`/engine/rule-channel-info/page?pageNo=${pageNo}&pageSize=${pageSize}&channelLevel=2&channelName=${channelName}&fullCode=${fullCode}&channelKey=${channelKey}&channelPartner=${channelPartner}`,
    method:'get'
  })
}
export function Channeldetails(pageNo,pageSize,channelName,channelPartner) {
  return request({
    url:`/engine/rule-channel-info/page?pageNo=${pageNo}&pageSize=${pageSize}&channelLevel=2&channelName=${channelName}&channelPartner=${channelPartner}`,
    method:'get'
  })
}
// 更新渠道信息
export function updateChannel(data){
  return request({
    url:`/engine/rule-channel-info/update`,
    method:'put',
    data:data
  })
}
export default function getKeyChannel (key) { 
  return request({
      url:`/engine/rule-channel-info/getChannelByKey?key=${key}`,
      method:'get'
  })
}


