import module from "@/util/module.js";
import { zIndexUp, zIndexDown } from "@/util/swap-array.js";
export default {
  // 拿到接口数据
  init(state, vals) {
    let val = vals
    for (let i = 0; i < val.pageList.length; i++) {
      val.pageList[i].pageStyle = JSON.parse(val.pageList[i].pageStyle);
      for (let j = 0; j < val.pageList[i].compList.length; j++) {
        val.pageList[i].compList[j].compStyle = JSON.parse(
          val.pageList[i].compList[j].compStyle
        );
      }
    }

    // 保存整个数据
    state.module.moduleConfig = JSON.parse(JSON.stringify(vals));
    // 分离数据
    if (state.module.moduleConfig.pageList.length > 0) {
      state.pageList = state.module.moduleConfig.pageList;
      if (state.pageList.length > 0) {
        state.diyPage = state.pageList[0];
        state.pageOnlyId = 0;
        if (state.diyPage.compList.length > 0) {
          state.compList = state.diyPage.compList;
          if (state.compList.length > 0) {
            state.control = state.compList[0];
            state.compOnlyId = 0;
          }
        }
      }
    }

    // id cid
  },
  // 保存页面信息
  keepPreview(state) {
    state.diyPage.compList = JSON.parse(JSON.stringify(state.compList))
    state.pageList[state.pageOnlyId] = JSON.parse(
      JSON.stringify(state.diyPage)
    );
    state.module.moduleConfig.pageList = JSON.parse(
      JSON.stringify(state.pageList)
    );
    console.log(state.module,"详细数据");
  },
  // 更改预览状态
  // keep只保存 否则进行预览
  setPreview(state, keep) {
    if (keep) {
      state.pageList[state.pageOnlyId] = JSON.parse(
        JSON.stringify(state.diyPage)
      );
      state.module.moduleConfig.pageList = JSON.parse(
        JSON.stringify(state.pageList)
      );
    }
    // 更改状态
    state.preview = !state.preview;
    state.compOnlyId = -1;
  },
  // 是否显示控件
  show(state) {
    state.showAttr = !state.showAttr;
  },
  ondiyPage(state) {
    // 将预览页面添加到页面列表中去
    state.pageList[state.pageOnlyId] = JSON.parse(
      JSON.stringify(state.diyPage)
    );
  },
  // 获取当前点击页面
  onPage(state, index) {
    // 如果预览页有数据
    if (JSON.stringify(state.diyPage) !== "{}") {
      // 保存预览页前页面信息
      state.pageList[state.pageOnlyId] = JSON.parse(
        JSON.stringify(state.diyPage)
      );
    } 
      // 如果预览页面中没有信息
      // 获取当前页面信息，并添加到预览页面中去
        state.diyPage = JSON.parse(JSON.stringify(state.pageList[index]));
        state.compList = JSON.parse(JSON.stringify(state.diyPage.compList));
        state.pageAttr = true
        state.pageOnlyId = index;
    // 将页面id替换成下标
  },
  // 重置信息
  Reset(state){
    state.module={};//项目信息
    state.pageList=[];//页面列表
    state.pageOnlyId=-1;//选定的页面id渲染在页面上的
    state.compOnlyId=-1;//正在展示的组件id
    state.globalStyle={};//全局样式
    state.diyPage= {};   // 当前正在展示的diy页面
    state.preview= false;//是否正在预览
    state.pageAttr=false;//是否显示页面管理面板
    state.compList=[]//组件列表
    state.control=[]//当前正在展示的组件，完整数据
  },
  // 增加页面 complist diy page
  addPageList(state) {
    // console.log(state.module,"page");

    // if (state.pageList.length == 0) {
    //   // let time = Date.now();
    //   let moduelObj = {
    //     moduleConfig: {
    //       creator: state.user.id,
    //       deleted: false,
    //       moduleName: "",
    //       moduleCode: "",
    //       logo: "1111",
    //       moduleDescribe: "",
    //       pageList: [],
    //     },
    //   };
    //   state.module = JSON.parse(JSON.stringify(moduelObj));
    // }
    state.diyPage.compList = JSON.parse(JSON.stringify(state.compList));
    state.pageList[state.pageOnlyId] = JSON.parse(
      JSON.stringify(state.diyPage)
    );
    state.compList = [];
    state.diyPage = [];

    // 新增自定义页面列表
    // 页面需要信息
    let obj = {
      // 页面配置，单独设置
      pageName: "自定义页面",
      pageCode: "",
      pageStyle: JSON.parse(JSON.stringify(module.PageGlobal)),
      operator: "",
      pageDescribe: "",
      createTime: "",
      updateTime: "",
      compList: [],
    };
    // 向页面列表添加数据
    state.pageList.push(obj);
    // 向预览页面内添加数据
    state.diyPage = JSON.parse(JSON.stringify(obj));
    // 当前正在展示的页面id
    state.pageOnlyId = state.pageList.length - 1;
    // 正在展示的组件列表
    state.compList = JSON.parse(
      JSON.stringify(state.pageList[state.pageOnlyId].compList)
    );
  },
  // 模板信息更改
  SetModuleConfig(state, val) {
    state.module.moduleConfig = JSON.parse(JSON.stringify(val));
  },
  copyPage(state){
    if (state.pageList.length<1) return;
    // console.log(state.diyPage);
    state.pageList.splice(state.pageOnlyId,0,state.pageList[state.pageOnlyId])
    state.pageOnlyId+=1
    // state.pageList[state.pageOnlyId].delete(id)
    if (state.pageList[state.pageOnlyId].id!="undefined") {
      delete state.pageList[state.pageOnlyId].id
    }
    state.pageList[state.pageOnlyId].compList.forEach(item => {
      if (item.id!='undefined') {
        delete item.id
      }
    });
    state.diyPage = JSON.parse(JSON.stringify(state.pageList[state.pageOnlyId]))

    console.log(state.pageList);
    
  },
  // 添加动画
  addAnimation(state, arr){
    state.control.compStyle.AnimationList.push(arr)
    state.compList[state.compOnlyId].compStyle.AnimationList = JSON.parse(
      JSON.stringify(state.control.compStyle.AnimationList)
    );
  },
  // 删除动画
  deleteAnimation (state,i) {
    state.control.compStyle.AnimationList.splice(i,1)
    state.compList[state.compOnlyId].compStyle.AnimationList = JSON.parse(
      JSON.stringify(state.control.compStyle.AnimationList))
  },
  // 删除页面    diyPage在删除第一个元素时无值
  deletPageList(state, index) {
    // 删除最后一个元素
    state.pageList.splice(index,1);
    if (index == state.pageOnlyId) {
      // 删除预览页面
      state.diyPage = [];
      // 删除组件列表
      state.compList = [];
    }
    // 页面信息
    state.pageOnlyId = state.pageList.length - 1;
    state.compOnlyId = -1;
    //
    if (index > 0) {
      state.diyPage = JSON.parse(JSON.stringify(state.pageList[index - 1]));
    }
    // 删除最后一个页面，退出预览
    if (index == 0) {
      state.preview = false;
    }
  },
  // 添加新的组件
  addComponent(state, index) {
    //如果存在组件， 保存上一个组件数据
    if (state.control.length == 1) {
      state.compList[state.compOnlyId] = JSON.parse(
        JSON.stringify(state.control)
      );
      //  清空当前正在展示的组件信息
    }
    // 新建组件
    let obj = {
      ...module.moduleList[0].list[index],
    };
    // 正在预览组件
    state.control = obj;
    state.compOnlyId = state.compList.length;
    state.compList.push(JSON.parse(JSON.stringify(obj)));
    state.diyPage.compList = JSON.parse(JSON.stringify(state.compList));
    // 获取对应页面id
  },
  deletAllComp(state){
    state.pageList[state.pageOnlyId].compList = JSON.parse(JSON.stringify(state.compList))
    state.compList = []
    state.control = []
    state.diyPage.compList = []
    state.compOnlyId = -1
  },
  //  删除组件
  deletComp(state, index) {
      // 如果没有组件
      if (state.compList.length <= 0) {
        return;
      } else {
        // 如果是唯一组件，删除后组件坐标归-1，
        if (state.compList.length==1) {
          // console.log(1);
          state.diyPage.compList.splice(index,1)
          state.compList = JSON.parse(JSON.stringify(state.diyPage.compList))
          state.compOnlyId = -1
          state.control = {}
        } else {
          // 删除当前，下个组件变成当前坐标元素
          state.diyPage.compList.splice(index,1)
          state.compList = JSON.parse(JSON.stringify(state.diyPage.compList))
          // 倒数第一个组件
          if (state.diyPage.compList.length==index) {
          state.compOnlyId = state.compList.length-1
          }else{
            state.compOnlyId = index
          }
          state.control = JSON.parse(JSON.stringify(state.compList[state.compOnlyId]))
          
        }
      }
  },
  //获取正在点击的组件
  onComp(state, index) {
    // 保存上个组件
    state.compList[state.compOnlyId] = JSON.parse(
      JSON.stringify(state.control)
    );
    // 保存到自定义页面中
    state.diyPage.compList[state.compOnlyId] = JSON.parse(
      JSON.stringify(state.control)
    );

    state.control = JSON.parse(JSON.stringify(state.compList[index]));
    state.compOnlyId = index;
    state.pageAttr = false;
  },
  // 更改组件列表
  setCompList(state, arr) {
    state.compList = JSON.parse(JSON.stringify(arr));
    state.diyPage.compList = JSON.parse(JSON.stringify(arr))
  },
  copyComp(state) {
    if (state.compList.length<1||state.pageList.length<1||state.diyPage.compList.length<1) return;
    state.compList.splice(state.compOnlyId,0,JSON.parse(JSON.stringify(state.compList[state.compOnlyId])));
    
    state.pageList.compList = JSON.parse(JSON.stringify(state.compList))
    state.compOnlyId += 1
    delete state.compList[state.compOnlyId].id
  },
  // 设置 组件配置
  setCompConfig(state, val) {
    state.control[val.name] = val.val;
    state.compList[state.compOnlyId][val.name] = val.val;
  },
  // 更改组件样式
  setCompStyle(state, val) {
    state.control.compStyle = JSON.parse(JSON.stringify(val));
    state.compList[state.compOnlyId].compStyle = JSON.parse(
      JSON.stringify(val)
    );
    state.compList = JSON.parse(JSON.stringify(state.compList));
    let date = new Date().getTime();
    state.update = date;
  },

  //  // 组件顺序变更
  // 拖动组件
  swap(state, index) {
    //更新数组数据
    //顺序切换，更新组件列表，获取当前组件，组件下标
    state.control = JSON.parse(JSON.stringify(state.compList[index]));
    state.compOnlyId = index;
  },
  // 
  dragDelete(state){
    state.compOnlyId -= 1;
    // console.log(state.compOnlyId);
    if (state.compOnlyId!=-1) {
      state.control = JSON.parse(JSON.stringify(state.compList[state.compOnlyId]));
    }
  },
  // 上
  compUp(state, index) {
    zIndexUp(state.compList, index, index - 1);
    state.control = state.compList[index - 1];
    state.compOnlyId -= 1;
  },
  // 下
  compDown(state, index) {
    zIndexDown(state.compList, index, index + 1);
    state.control = state.compList[index + 1];
    state.compOnlyId += 1;
  },
  // 置顶，
  compTop(state, index) {
    // 插入到第一条
    state.compList.unshift(state.compList[index]);
    // 删除当前条
    state.diyPage.compList.splice(index + 1, 1);
    state.compList.splice(index + 1, 1);
    state.compOnlyId = 0;
  },
  // 置底
  compBottom(state, index) {
    state.compList.push(state.compList[index]);
    state.diyPage.compList.splice(index, 1);
    state.compList.splice(index, 1);
    state.compOnlyId = state.compList.length - 1;
  },

  // 修改module配置信息
  setModule(state, obj) {
    state.module.moduleConfig = JSON.parse(JSON.stringify(obj));
    // state.module.
    // let date = new Date().getTime()
    // state.PageUpdate = date
  },
  //修改全局样式
  setDiyPageStyle(state, obj) {
    state.diyPage.pageStyle = JSON.parse(JSON.stringify(obj));
    let date = new Date().getTime();
    state.pageUpdate = date;
  },

  // 更新页面配置
  setPageData(state, val) {
    state.diyPage[val.name] = val.val;
    state.pageList[state.pageOnlyId][val.name] = val.val;
    let date = new Date().getTime();
    state.pageUpdate = date;
  },

  //配置显示
  showPageAttr(state) {
    state.pageAttr = true;
  },
  // 预览 切换
  // 下一页
  nextPage(state) {
    state.pageOnlyId += 1;
    state.diyPage = JSON.parse(
      JSON.stringify(state.pageList[state.pageOnlyId])
    );
    state.compList = JSON.parse(JSON.stringify(state.diyPage.compList));
  },
  // 上一页
  prevPage(state) {
    // 预览页面
    // 页面列表中
    // 页面下标
    state.pageOnlyId -= 1;
    state.diyPage = JSON.parse(
      JSON.stringify(state.pageList[state.pageOnlyId])
    );
    state.compList = JSON.parse(JSON.stringify(state.diyPage.compList));
  },
  updateScale(state,val){
    state.scale = val
  }
};
