export default async function runAnimation($el, animations = []) {
    $el.classList.forEach((res) => {
        if (res == "infinite") {
            $el.classList.remove("infinite");
        }
    });
    const play = (animation) =>
        new Promise((resolve) => {
            const { animationTime, value, isLoop } = animation;
            // 设置当前元素动画时长
            $el.style.setProperty("animation-duration", `${animationTime}s`);
            // 添加动画
            $el.classList.add(value, "animated", utilsHandle(isLoop));
            const removeAnimation = () => {
                // 添加事件（动画结束，动画开始）
                // 如果此时当前动画开始或者结束执行则，再次停止
                $el.removeEventListener("animationend", removeAnimation);
                $el.removeEventListener("animationcancel", removeAnimation);
                // 删除属性
                $el.classList.remove(value, "animated", utilsHandle(isLoop));
                // 删除动画时长
                $el.style.removeProperty("animation-duration");
                resolve(); //已完成
            };
            // 动画结束事件
            $el.addEventListener("animationend", removeAnimation);
            // 动画开始事件
            $el.addEventListener("animationcancel", removeAnimation);
        });

    for (let i = 0, len = animations.length; i < len; i++) {
        await play(animations[i]);
    }
}

function utilsHandle(isLoop) {
    return isLoop ? "infinite" : "no-infinite";
}
